From cdf2904404c7510832f173a696e7f7c4febfded1 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Fri, 21 Aug 2020 21:37:08 +0800
Subject: [PATCH] Add dbus build shell script

---
 3rdparty/dbus/build.sh |  102 +++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 102 insertions(+), 0 deletions(-)

diff --git a/3rdparty/dbus/build.sh b/3rdparty/dbus/build.sh
new file mode 100755
index 0000000..371f6a4
--- /dev/null
+++ b/3rdparty/dbus/build.sh
@@ -0,0 +1,102 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile dbus for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PRJ_PATH=`pwd`
+PREFIX_PATH=`pwd`/../install
+mkdir -p ${PREFIX_PATH}/{bin,sbin,include,lib}
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/xtools/arm920t/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_dbus()
+{
+    SRC_NAME=dbus-1.12.2
+    PACK_SUFIX=tar.gz
+    IMG_NAME=libdbus-1.a
+
+    if [ -f ${PREFIX_PATH}/lib/${IMG_NAME} ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        #wget https://dbus.freedesktop.org/releases/dbus/${SRC_NAME}.${PACK_SUFIX}
+        wget $LYFTP_SRC/$SRC_NAME.$PACK_SUFIX
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    export EXPAT_CFLAGS=-I${PREFIX_PATH}/include/
+    export EXPAT_LIBS="-L${PREFIX_PATH}/lib -lexpat"
+
+    echo ac_cv_have_abstract_sockets=yes>arm-linux.cache
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static --cache-file=arm-linux.cache \
+        --disable-systemd  --disable-launchd --disable-selinux --with-x=no --disable-tests
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make  && make install
+    check_result "ERROR: compile ${SRC_NAME} failure"
+
+    cd -
+}
+
+cd ../expat && ./build.sh && cd -
+
+export_cross
+
+compile_dbus
+
+

--
Gitblit v1.9.1